//+------------------------------------------------------------------+
//|                                  Overbust Makaca Gumanoid 1.1.mq4 |
//|                                                           Contra |
//|                                            http://www.contra.com |
//+------------------------------------------------------------------+
#property copyright "Contra"
#property link      "http://www.contra.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Crimson
#property indicator_color2 Lime

extern int MAIN_Period = 7;
extern int ADX_Period = 7;
extern int MAX_Bars = 1000;
extern bool Sound_alert = FALSE;

double G_ibuf_104[];
double G_ibuf_108[];
double G_ibuf_112[];
double G_ibuf_116[];
string Gs_120;
string Gs_128;
datetime G_time_136;
int Gi_140 = 0;

void init() {
   IndicatorBuffers(4);
   SetIndexBuffer(0, G_ibuf_108);
   SetIndexBuffer(1, G_ibuf_104);
   SetIndexBuffer(2, G_ibuf_112);
   SetIndexBuffer(3, G_ibuf_116);
   SetIndexLabel(0, "SELL SIGN");
   SetIndexLabel(1, "BUY SIGN");
   SetIndexEmptyValue(0, EMPTY_VALUE);
   SetIndexEmptyValue(1, EMPTY_VALUE);
   SetIndexEmptyValue(2, EMPTY_VALUE);
   SetIndexEmptyValue(3, EMPTY_VALUE);
   SetIndexStyle(0, DRAW_ARROW, STYLE_SOLID, 3);
   SetIndexArrow(0, 218);
   SetIndexStyle(1, DRAW_ARROW, STYLE_SOLID, 3);
   SetIndexArrow(1, 217);
   G_time_136 = Time[0];
   Gs_120 = "";
}

int deinit() {
   Gs_120 = "";
   ObjectsDeleteAll();
   return (0);
}

void start() {
   double isar_0;
   double isar_8;
   double Ld_16;
   double iadx_24;
   int Li_32;
   if (Bars > 10) {
      Gi_140 = IndicatorCounted();
      if (Gi_140 >= 0) {
         if (Gi_140 > 0) Gi_140--;
         Li_32 = MathMin(Bars - Gi_140 - 1, MAX_Bars);


            Ld_16 = MathAbs(Bid - Ask);

         while (Li_32 >= 0) 
         {
isar_8 = iSAR(Symbol(), 0, NormalizeDouble(1 / (100 * MAIN_Period - 0.01), 3), 0.5, Li_32 + 1);
isar_0 = iSAR(Symbol(), 0, NormalizeDouble(1 / (100 * MAIN_Period - 0.01), 3), 0.5, Li_32);
iadx_24 = iADX(Symbol(), 0, ADX_Period, PRICE_CLOSE, MODE_MAIN, Li_32);

if ((isar_0 > Close[Li_32] && isar_8 < Close[Li_32 + 1] && iadx_24 > 20.0) ||  (isar_0 < Close[Li_32] && isar_8 < Close[Li_32 + 1] && iadx_24 < 700.0))   
    {
G_ibuf_108[Li_32] = High[Li_32] + MathAbs(Close[Li_32] - Open[Li_32]) / 2.0 + 4.0 * MathAbs(Bid - Ask);
               ObjectDelete("Pokupay");
               ObjectCreate("Prodavay", OBJ_LABEL, 0, 0, 0);
               ObjectSet("Prodavay", OBJPROP_CORNER, 1);
               ObjectSet("Prodavay", OBJPROP_XDISTANCE, 54);
               ObjectSet("Prodavay", OBJPROP_YDISTANCE, 21);
               ObjectSetText("Prodavay", "Prodavay", 32, "Arial Black", Crimson);
               if (Li_32 == 0 && Time[0] > G_time_136) {
                  if (Period() < PERIOD_M1) Alert("SELL SIGN: " + Symbol() + "  |  TIMEFRAME: M1" + Period() + "  |  PRICE(BID): " + DoubleToStr(Bid, MarketInfo(Symbol(), MODE_DIGITS)) + " ");
                  if (Period() == PERIOD_M1) Alert("SELL SIGN: " + Symbol() + "  |  TIMEFRAME: M1  |  PRICE(BID): " + DoubleToStr(Bid, MarketInfo(Symbol(), MODE_DIGITS)) + " ");
                  if (Period() == PERIOD_M5) Alert("SELL SIGN: " + Symbol() + "  |  TIMEFRAME: M5  |  PRICE(BID): " + DoubleToStr(Bid, MarketInfo(Symbol(), MODE_DIGITS)) + " ");
                  if (Period() == PERIOD_M15) Alert("SELL SIGN: " + Symbol() + "  |  TIMEFRAME: M15  |  PRICE(BID): " + DoubleToStr(Bid, MarketInfo(Symbol(), MODE_DIGITS)) + " ");
                  if (Period() == PERIOD_M30) Alert("SELL SIGN: " + Symbol() + "  |  TIMEFRAME: M30  |  PRICE(BID): " + DoubleToStr(Bid, MarketInfo(Symbol(), MODE_DIGITS)) + " ");
                  if (Period() == PERIOD_H1) Alert("SELL SIGN: " + Symbol() + "  |  TIMEFRAME: H1|  PRICE(BID): " + DoubleToStr(Bid, MarketInfo(Symbol(), MODE_DIGITS)) + " ");

                  if (Sound_alert == TRUE) PlaySound("alert.wav");
               }
               G_time_136 = Time[0];
            }
if ((isar_0 < Close[Li_32] && isar_8 > Close[Li_32 + 1] && iadx_24 > 20.0) || (isar_0 > Close[Li_32] && isar_8 > Close[Li_32 + 1] && iadx_24 < 50.0))
            {
G_ibuf_104[Li_32] = Low[Li_32] - MathAbs(Close[Li_32] - Open[Li_32]) / 2.0 - 4.0 * MathAbs(Bid - Ask);//MathCeil //MathAbs
               ObjectDelete("Prodavay");
               ObjectCreate("Pokupay", OBJ_LABEL, 0, 0, 0);
               ObjectSet("Pokupay", OBJPROP_CORNER, 1);
               ObjectSet("Pokupay", OBJPROP_XDISTANCE, 54);
               ObjectSet("Pokupay", OBJPROP_YDISTANCE, 21);
               ObjectSetText("Pokupay", "Pokupay", 32, "Arial Black", Lime);
               if (Li_32 == 0 && Time[0] > G_time_136) {
                  if (Period() < PERIOD_M1) Alert("BUY SIGN: " + Symbol() + "  |  TIMEFRAME: M1" + Period() + "  |  PRICE(ASK): " + DoubleToStr(Ask, MarketInfo(Symbol(), MODE_DIGITS)) + " ");
                  if (Period() == PERIOD_M1) Alert("BUY SIGN: " + Symbol() + "  |  TIMEFRAME: M1  |  PRICE(ASK): " + DoubleToStr(Ask, MarketInfo(Symbol(), MODE_DIGITS)) + " ");
                  if (Period() == PERIOD_M5) Alert("BUY SIGN: " + Symbol() + "  |  TIMEFRAME: M5  |  PRICE(ASK): " + DoubleToStr(Ask, MarketInfo(Symbol(), MODE_DIGITS)) + " ");
                  if (Period() == PERIOD_M15) Alert("BUY SIGN: " + Symbol() + "  |  TIMEFRAME: M15  |  PRICE(ASK): " + DoubleToStr(Ask, MarketInfo(Symbol(), MODE_DIGITS)) + " ");
                  if (Period() == PERIOD_M30) Alert("BUY SIGN: " + Symbol() + "  |  TIMEFRAME: M30  |  PRICE(ASK): " + DoubleToStr(Ask, MarketInfo(Symbol(), MODE_DIGITS)) + " ");
                  if (Period() == PERIOD_H1) Alert("BUY SIGN: " + Symbol() + "  |  TIMEFRAME: H1  |  PRICE(ASK): " + DoubleToStr(Ask, MarketInfo(Symbol(), MODE_DIGITS)) + " ");

                  if (Sound_alert == TRUE) PlaySound("alert.wav");
               }
               G_time_136 = Time[0];
            }
            Li_32--;
         }
      }
   }
	return;
}